"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.is_extensionless = exports.strip_extension = exports.is_import_call = exports.is_normal_call = void 0;
var path = __importStar(require("path"));
var is_normal_call = function (node_path, types, functions) {
    var node = node_path.node;
    return functions.some(function (pattern) {
        if (types.isMemberExpression(node)) {
            return node_path.matchesPattern(pattern);
        }
        if (!types.isIdentifier(node) || pattern.includes('.')) {
            return false;
        }
        var name = pattern.split('.')[0];
        return node.name === name;
    });
};
exports.is_normal_call = is_normal_call;
var is_import_call = function (node_path, types) {
    if (!types.isCallExpression(node_path.node))
        return false;
    return types.isImport(node_path.node.callee);
};
exports.is_import_call = is_import_call;
var strip_extension = function (filepath, extensions, platform_extensions) {
    if (is_extensionless(filepath, extensions)) {
        return filepath;
    }
    var parsed = path.parse(filepath);
    var result = "".concat(parsed.dir).concat(path.sep).concat(parsed.name);
    if (platform_extensions.includes(parsed.ext)) {
        result += ".".concat(parsed.ext);
    }
    return result;
};
exports.strip_extension = strip_extension;
var is_extensionless = function (filepath, extensions) {
    var is_extensionless = true;
    for (var _i = 0, extensions_1 = extensions; _i < extensions_1.length; _i++) {
        var extension = extensions_1[_i];
        if (filepath.endsWith(".".concat(extension))) {
            is_extensionless = false;
            break;
        }
    }
    return is_extensionless;
};
exports.is_extensionless = is_extensionless;
