"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallVisitor = exports.default = void 0;
var path = __importStar(require("path"));
var utils = __importStar(require("../utils"));
var resolver = __importStar(require("../resolver"));
var CallVisitor = function (node_path, state) {
    var types = state.types;
    var options = state.normalized_options;
    var visited_nodes = state.babel_platform_resolver_visited_nodes;
    if (visited_nodes.has(node_path))
        return;
    var current_file = state.file.opts.filename;
    var basedir = path.dirname(current_file);
    if (utils.is_normal_call(node_path.get('callee'), types, options.transform_functions) ||
        utils.is_import_call(node_path, types)) {
        var arg0 = node_path.get('arguments.0');
        if (!types.isStringLiteral(arg0.node))
            return;
        var import_path = arg0.node.value;
        var alternative_path = resolver.resolve(import_path, __assign(__assign({}, options), { basedir: basedir }));
        if (!alternative_path)
            return;
        visited_nodes.add(node_path);
        arg0.replaceWith(types.stringLiteral(alternative_path));
    }
};
exports.default = CallVisitor;
exports.CallVisitor = CallVisitor;
